<?php
/*
+---------------------------------------------------------------+
|        Gold Orb for e107 v7xx - by Father Barry
|
|        This module for the e107 .7+ website system
|        Copyright Barry Keal 2004-2008
|
|        Released under the terms and conditions of the
|        GNU General Public License (http://gnu.org).
|
+---------------------------------------------------------------+
*/
require_once('../../class2.php');
if (!defined('e107_INIT'))
{
    exit;
}

include_lan(e_PLUGIN . "gold_orb/languages/" . e_LANGUAGE . ".php");
if (substr($pref['plug_installed']['gold_system'], 0, 1) < 4)
{
    require_once(HEADERF);
    print GOLD_ORB_115;
    require_once(FOOTERF);
    exit;
}
if (!is_object($gold_obj))
{
    require_once(e_PLUGIN . 'gold_system/includes/gold_class.php');
    $gold_obj = new gold;
}
if (!$gold_obj->plugin_active('gold_orb'))
{
    require_once(HEADERF);
    print GOLD_ORB_116;
    require_once(FOOTERF);
    exit;
}

require_once(e_HANDLER . 'userclass_class.php');
require_once(e_HANDLER . 'file_class.php');
$gorb_fclass = new e_file;

if (!is_object($gorb_obj))
{
    require_once(e_PLUGIN . 'gold_orb/includes/gold_orb_class.php');
    $gorb_obj = new gold_orb;
}
if (file_exists(THEME . '/images/gold_orb_logo.png'))
{
    define(GORB_LOGO, THEME . '/images/gold_orb_logo.png');
} elseif (file_exists(e_PLUGIN . 'gold_orb/images/gold_orb_logo.png'))
{
    define(GORB_LOGO, e_PLUGIN . 'gold_orb/images/gold_orb_logo.png');
}
require_once(HEADERF);

if (!defined('USER_WIDTH'))
{
    define(USER_WIDTH, 'width:100%;');
}
if (file_exists(THEME . 'gold_orb_template.php'))
{
    define(GORB_THEME, THEME . 'gold_orb_template.php');
}
else
{
    define(GORB_THEME, e_PLUGIN . 'gold_orb/templates/gold_orb_template.php');
}
require_once(GORB_THEME);

require_once(e_PLUGIN . 'gold_orb/includes/gold_orb_shortcodes.php');
if (isset($_POST['gorb_unwield']))
{
    $gorb_message = GOLD_ORB_122;
    $gold_sql->db_Update('gold_system', "gold_orb='' WHERE gold_id='" . USERID . "'", false);
    $gold_obj->load_gold(USERID);
}
// *****************************************************************************
// * Buy an orb
// *****************************************************************************
if (isset($_POST['gorb_buy']))
{
    $gorb_orbfolder = key($_POST['gorb_buy']);

    $gorb_obj->buy_orb($gorb_orbfolder, USERID);
    $gorb_data = unserialize($GOLD_ORB_PREF['gorb_obs']);
    // get the orb details
    require(e_PLUGIN . 'gold_orb/orbs/' . $gorb_orbfolder . '/orb.php');
    $gorb_title = $gorb[$gorb_orbfolder]['title'];
    // make the message
    $gorb_message = GOLD_ORB_118 . ' <b>' . $gorb_title . '</b>';
    // charge the user
    $gold_param['gold_user_id'] = USERID;
    $gold_param['gold_who_id'] = 0;
    $gold_param['gold_amount'] = $gorb_data[$gorb_orbfolder ]['cost'];
    $gold_param['gold_type'] = GOLD_ORB_120;
    $gold_param['gold_action'] = 'debit';
    $gold_param['gold_plugin'] = 'gold_orb';
    $gold_param['gold_log'] = GOLD_ORB_121 . ' ' . $gorb_title;
    $gold_param['gold_forum'] = 0;
    $gold_obj->gold_modify($gold_param, false);
}
if (isset($_POST['gorb_wield']))
{
    $gorb_orbfolder = key($_POST['gorb_wield']);
    // print $gorb_orbfolder;
    $gorb_obj->wield_orb($gorb_orbfolder, USERID);
    // get the orb details
    require(e_PLUGIN . 'gold_orb/orbs/' . $gorb_orbfolder . '/orb.php');
    $gorb_title = $gorb[$gorb_orbfolder]['title'];
    $gorb_message = GOLD_ORB_119 . ' <b>' . $gorb_title . '</b>';
}
$gorb_cached = $e107cache->retrieve('gold_orbs');
// don't use cache yet.
if ($gorb_cached == 222)
{
    echo $gorb_cached;
}
else
{
    // get the current users orbs
    $gorb_omit = array('^\.$', '^\.\.$', '^\/$', '^CVS$', 'thumbs\.db', '.*\._$', '^\.htaccess$', 'index\.html', 'null\.txt', '\.LCK');
    // scan the orb directories for all orbs
    $gorb_list = $gorb_fclass->get_files('orbs/', 'orb.php', $gorb_omit, 1);
    // print_a($gorb_list);
    if (isset($_POST['gorb_sub']))
    {
        // print_a($_POST);
        foreach($_POST['gorb_folder'] as $gorb_key => $gorb_folder)
        {
            $gorb_array[$gorb_folder]['cost'] = $_POST['gorb_cost'][$gorb_key];
            $gorb_array[$gorb_folder]['class'] = $_POST['gorb_class'][$gorb_key];
        }
        $GOLD_ORB_PREF['gorb_obs'] = serialize($gorb_array);
        $gorb_obj->save_prefs();
        $gorb_msg .= '<strong>' . GOLD_ORB_C_05 . '</strong>';
    }
    unset($gorb_data);
    $gorb_data = unserialize($GOLD_ORB_PREF['gorb_obs']);
    // print_a($gorb_data);
    $gorb_cuser = unserialize($gold_obj->gold_member[USERID]['gold_inv']);
    $gorb_text .= '
<script type="text/javascript">
function gorb_ConfirmPurchase(item,cost)
{
	return confirm("' . GOLD_ORB_107 . ' - " +item + " ' . GOLD_ORB_117 . ' " + cost);
}
</script>
<form method="post" action="' . e_SELF . '" id="gorb_buyorbs" >';
    $gorb_text .= $tp->parsetemplate($GOLD_ORB_HEADER, true, $gorb_shortcodes);
    $sql->db_Select('gold_orb_cat', '*', 'order by gorb_cat_name', 'nowhere', false);
    while ($gorb_catrow = $sql->db_Fetch())
    {
        $gorb_catlist[$gorb_catrow['gorb_cat_id']] = $tp->toFORM($gorb_catrow['gorb_cat_name']);
        $gorb_tabs .= "'" . $tp->toFORM($gorb_catrow['gorb_cat_name']) . "',";
    }
    $gorb_tabs = substr($gorb_tabs, 0, -1);
    // print_a($gorb_tabs);
    $gorb_text .= '
<table style="' . USER_WIDTH . '">
	<tr>
		<td>
			<div id="gold_orb" style="width:100%">';
    foreach($gorb_list as $gorb_orbmain)
    {
        require(e_PLUGIN . 'gold_orb/' . $gorb_orbmain['path'] . '/' . $gorb_orbmain['fname']);
        // print $gorb_folder."<br>";
        // find out if orb is jpg, png or gif
        if (is_readable(e_PLUGIN . 'gold_orb/samples/' . $gorb_folder . '.png'))
        {
            $gorb_orbfile = 'png';
        } elseif (is_readable(e_PLUGIN . 'gold_orb/samples/' . $gorb_folder . '.jpg'))
        {
            $gorb_orbfile = 'jpg';
        } elseif (is_readable(e_PLUGIN . 'gold_orb/samples/' . $gorb_folder . '.gif'))
        {
            $gorb_orbfile = 'gif';
        }
        else
        {
            $gorb_orbfile = '';
        }
        // print "file $gorb_orbfile<br>";
        if ($GOLD_ORB_PREF['gorb_regen'] == 1 || empty($gorb_orbfile))
        {
            // make a sample orb
            // print "$gorb_orbfile";
            $gorb_obj->gen_orb($gorb_folder, GOLD_ORB_O_04, $gorb[$gorb_folder], true);
        }
        $gorb_button = '';

        if (check_class($gorb_data[$gorb_folder]['class']))
        {
            if (in_array($gorb_folder, $gorb_cuser))
            {
                // print $gorb_folder;
                if ($gorb_folder == $gold_obj->gold_member[USERID]['gold_orb'])
                {
                    // $gorb_text .= GOLD_ORB_112;
                    $gorb_button .= '<input type="submit" class="button" name="gorb_unwield" value="' . GOLD_ORB_123 . '" />';
                }
                else
                {
                    $gorb_button .= '<input type="submit" class="button" name="gorb_wield[' . $gorb_folder . ']" value="' . GOLD_ORB_111 . '" /> ';
                }
            }
            else
            {
                if ($gorb_data[$gorb_folder]['cost'] > $gold_obj->gold_balance(USERID))
                {
                    $gorb_button .= GOLD_ORB_113;
                }
                else
                {
                    $gorb_button .= '<input type="submit" class="button" onclick="return gorb_ConfirmPurchase(\'' . $gorb[$gorb_folder]['title'] . '\',' . $gorb_data[$gorb_folder]['cost'] . ')" name="gorb_buy[' . $gorb_folder . ']" value="' . GOLD_ORB_110 . '" /> ';
                }
            }
        }
        else
        {
            $gorb_button .= GOLD_ORB_114;
        }
        if (($GOLD_ORB_PREF['gorb_showall'] != 1 && check_class($gorb_data[$gorb_folder]['class'])) || $GOLD_ORB_PREF['gorb_showall'] == 1)
        {

            $gorb_content[$gorb_catlist[$gorb_data[$gorb_folder]['category']]] .= $tp->parsetemplate($GOLD_ORB_ORB, true, $gorb_shortcodes);
        }
    }
    ksort($gorb_content);
    // print_a($gorb_catlist);
    foreach($gorb_catlist as $value)
    {
        $row = $gorb_content[$value];
        if (empty($row))
        {
            $row = GOLD_ORB_124;
        }
        $gorb_text .= '
  <div class="dhtmlgoodies_aTab">' . $row . '
  </div>';
    }

    $gorb_text .= $tp->parsetemplate($GOLD_ORB_FOOTER, true, $gorb_shortcodes);
    $gorb_text .= '
			</div>
		</td>
	</tr>
</table>
</form>';
    $gorb_text .= '

<script type="text/javascript">
var tabviewfolder="' . SITEURL . $PLUGINS_DIRECTORY . 'gold_system/includes/tabview/"
initTabs(\'gold_orb\',Array(' . $gorb_tabs . '),0,\'100%\',\'\');
</script>';
    ob_start();
    $ns->tablerender(GOLD_ORB_C_01, $gorb_text);
    $cache_data = ob_get_flush(); // Get the page content, and display it
    $e107cache->set(USERID . '_gold_orbs', $cache_data);
}
require_once(FOOTERF);
